/*
   Copyright (C) Eiwa System Management 1998
   This program is free software.

   This program is provided AS IS, with NO WARRANTY.
*/
package sun.tools.javadoc;

import java.util.*;
import java.io.*;
import sun.tools.java.*;
import java.lang.reflect.Modifier;
import sun.tools.javac.BatchEnvironment;
import sun.tools.tree.LocalField;


/*
 * ̃t@C̖RgɁCR[fBȌڍ׃񂠂D
 */
/**
  * The RedDocumentationGenerator class.
  * <br>
  * Rose p̃C|[gt@C(.red)쐬ṕCDocumentationGenerator.
  * sun.tools.javadoc.DocumentGenerator  package friendly ȃXR[v
  * ł邽߁C̃NX sun.tools.javadoc package Ƃč쐬
  * ȂDsun.tools.javadoc.Main  "-doctype Red " IvVŋN
  * 邱ƂŁC̃NXgpD
  *
  * $Log: RedDocumentationGenerator.java,v $
  * Revision 1.7  1998/03/21  06:16:00  hiranabe
  * deprecated -> english
  *
  * Revision 1.6  1998/03/16  03:00:43  hiranabe
  * *** empty log message ***
  *
  * Revision 1.5  1998/03/16  00:37:00  hiranabe
  * category '/' -> '.'
  *
  * Revision 1.4  1998/03/14  08:29:39  okamura
  * *** empty log message ***
  *
  * Revision 1.3  1997/12/19  09:35:44  hiranabe
  * bug for package red file creation
  * when interface or execption class exist, some classes are added twice
  *
  * Revision 1.2  1997/12/18  09:42:52  hiranabe
  * RCS comment
  *
  *
  * @version 1.0 $Revision: 1.7 $ $Date: 1998/03/21 06:16:00 $
  * @author hiranabe, okamura
  */
class RedDocumentationGenerator extends DocumentationGenerator {
    /**
      * o͗p̃f~^C^[~l[^.
      */
    private static final String NL = System.getProperty("line.separator"); 
    private static final String TAB = "\t"; 
    private static final String TAB2 = "\t\t"; 
    private static final String TAB3 = "\t\t\t"; 
    private static final String TAB4 = TAB2 + TAB2; 

    /**
      * ݏ̃NX.
      * DocumentationGenerator#getSees ŎgpD
      */
    ClassDeclaration currentClass = null;
    Vector allFields = new Vector();

    /**
      * genDocumentation p̃tO
      */
    static final int C_VARIABLE = 0;
    static final int C_CONSTRUCTOR = 1;
    static final int C_METHOD = 2;

    /**
      * Packages.html ̍쐬p.
      * Red ł́CȂD
      */
    void genPackagesDocumentation(String[] s, String[] t)  { }

    /**
      * Tree.html ̍쐬p.
      * Red ł͉ȂD
      */
    void genClassTree(Hashtable h, ClassDeclaration cd) { }

    /**
      * Red ł͂ȂɂȂ
      */
    void genFieldIndex() { }

    /**
      * Package.html ̍쐬p.
      * Red ł́CeNX Red ܂Ƃ߂̂쐬C
      * Package.red ƂD
      * @param packageIdentifier pbP[W
      * @param interfaceDeclaration C^[tFCX̔z
      * @param classDeclaration NX̔z
      * @param exceptionDeclaration O̔z
      * @param errorDeclaration G[̔z
      */
    void genPackageDocumentation(Identifier packageIdentifier,
				 ClassDeclaration[] interfaceDeclaration,
				 ClassDeclaration[] classDeclaration,
				 ClassDeclaration[] exceptionDeclaration,
				 ClassDeclaration[] errorDeclaration) {

	//* pbP[W + .red Ƃt@CƂD
        PrintWriter printWriter = DocumentationGenerator.openFile(packageIdentifier.toString() + ".red");
	ClassDefinition classDefinition = null;


	//* ꂼ̃NX̃hLg쐬
	redStart(printWriter);
	for (int i = 0; i < classDeclaration.length; i++) {
	    genClassDocumentationContents(printWriter, classDeclaration[i]);
	}
	for (int i = 0; i < interfaceDeclaration.length; i++) {
	    genClassDocumentationContents(printWriter, interfaceDeclaration[i]);
	}
	for (int i = 0; i < exceptionDeclaration.length; i++) {
	    genClassDocumentationContents(printWriter, exceptionDeclaration[i]);
	}
	for (int i = 0; i < errorDeclaration.length; i++) {
	    genClassDocumentationContents(printWriter, errorDeclaration[i]);
	}
	redEnd(printWriter);
    }

    /**
      * Generates Class Documentation.
      * <br>
      * <Class>.html ̍쐬pD
      * Red ł́CClass.red 쐬D
      * @param classDeclaration NX錾
      * @param prevClass 1ÕNX(html {^쐬p)Dred ł͎gpȂD
      * @param nextClass 1̃NX(html {^쐬p)Dred ł͎gpȂD
      */
    void genClassDocumentation(ClassDeclaration classDeclaration,
			       ClassDeclaration prevClass, ClassDeclaration nextClass) {
        ClassDefinition classDefinition = null;
        String className = null;
        PrintWriter printWriter = null;
        System.out.println(Main.getText("html.Generating_documentation_for", classDeclaration.toString()));
	//* open file.
        try {
            classDefinition = getClassDefinition(classDeclaration);
	    className = classDefinition.getName().getName().toString();
            printWriter = DocumentationGenerator.openFile(new StringBuffer(className).append(".red").toString());
	    
        }
        catch (ClassNotFound classNotFound) {
            System.out.println(Main.getText("html.Warning_Could_not_find_class_info_for", classDeclaration.toString()));
            return;
        }

	//* generates contents.
	redStart(printWriter);
	genClassDocumentationContents(printWriter, classDeclaration);  // this is the body method.
	redEnd(printWriter);

    }

    /**
      * Generates the contenets of the Class documentation.
      */
    void genClassDocumentationContents(PrintWriter printWriter, ClassDeclaration classDeclaration) {

	ClassDefinition classDefinition = null;
	try {
	    classDefinition = getClassDefinition(classDeclaration);
	} catch (ClassNotFound classNotFound) {
            System.out.println(Main.getText("html.Warning_Could_not_find_class_info_for", classDeclaration.toString()));
	    return;
        }

	currentClass = classDeclaration;
	boolean isInterface = classDefinition.isInterface();	
	String packageName = classDefinition.getName().getQualifier().toString();
	String className = classDefinition.getName().getName().toString();
	//packageName = packageName.replace('.', '/');

	//* print Class_Category
	// opens 2 paren
	printWriter.println(
	    "(object Class_Category \"" + packageName + "\"" + NL +
	    TAB + "exportControl \"Public\"" + NL +
	    TAB + "documentation \"\"" + NL +
	    TAB + "logical_models (list unit_reference_list"
	    );

	//* print Class
	// opens 1 paren
	printWriter.println(
	    "(object Class \"" + className + "\""
	    );

	//* class documents
        String classDoc = classDefinition.getDocumentation();
	// generates all comments here
	genAllComments(printWriter, classDoc, null);

	    // may be no need for now.
//		printWriter.println(
//		    TAB + "persistence \"Transient\"" + NL +
//		    TAB + "concurrency \"Sequential\""
//		    );

	//* access modifier
	int mod = classDefinition.getModifiers();
	if (Modifier.isAbstract(mod) || isInterface) {
	    printWriter.println(
		TAB + "abstract" + TAB + "TRUE"
		);
	}
	
	//* print superclasses
	// open 1 paren
	ClassDeclaration superClass = classDefinition.getSuperClass();
	ClassDeclaration interfaces[] = classDefinition.getInterfaces();
	if (superClass != null || (interfaces != null && 0 < interfaces.length)) {
	    printWriter.println(
		TAB + "superclasses (list inheritance_relationship_list"
		);

	    //* first, superclasses
	    if (superClass != null) {
		String superClassPackageName = superClass.getName().getQualifier().toString();
		//superClassPackageName = superClassPackageName.replace('.','/');

		String superClassName = superClass.getName().getName().toString();;

//		if (!superClassPackageName.equals(packageName)) {
//		    // full classname . e.g. java.awt.Color
//		    superClassName = getReferenceName(superClass.getName());
//		    //superClassName = superClassName.replace('.','/');
//		}

		printWriter.println(
		    TAB + "(object Inheritance_Relationship" + NL +
		    TAB + "supplier \"" + superClassName + "\"" + ")"
		    );

/*
		// add by okamura
		String superClassName2 = superClass.getName().getName().toString();
		//superClassName2 = superClassName2.replace('.','/');
		printWriter.println(
		    TAB + "(object Inheritance_Relationship" + NL +
		    TAB + "supplier \"" + superClassName2 + "\"" + ")"
		    );
*/
	    }

	    //* then interfaces (not in this version)
	    /******** NO INTERFACE for now.
	    interfaces = classDefinition.getInterfaces();
	    for (int i = 0; i < interfaces.length; i++) {
		String interfaceName = getReferenceName(interfaces[i].getName());
		//interfaceName = interfaceName.replace('.','/');
		printWriter.println(
		    TAB + "(object Inheritance_Relationship" + NL +
		    TAB + "supplier \"" + interfaceName + "\"" + ")"
		    );
	    }
	    ************/
	    //* close paren for superclasses.
	    printWriter.println(
		    TAB + ")"
		);
	}

	Vector vars = DocumentationGenerator.allVariables(classDefinition);
	Vector consts = DocumentationGenerator.allConstructors(classDefinition);
	Vector methods = DocumentationGenerator.allMethods(classDefinition);

	//* generates each fields' comments.
	vars = DocumentationGenerator.localFieldsOf(classDefinition, vars);
	methods = DocumentationGenerator.localFieldsOf(classDefinition, methods);
	consts = DocumentationGenerator.localFieldsOf(classDefinition, consts);

	//* oϐɂĂ̏o.
	genDocumentation(printWriter, vars, C_VARIABLE);

	//* RXgN^ɂĂ̏o.
	genDocumentation(printWriter, consts, C_CONSTRUCTOR);

	//* \bhɂĂ̏o.
	genDocumentation(printWriter, methods, C_METHOD);

	//* End class.
	// close 3 parens for class
	printWriter.println(
	    TAB + ")))"
	    );
    }

    /**
      * oϐRXgN^,\bh̏o͂.
      * @param printWriter  o͐. (*.red t@C֏o͂).
      * @param vector o͏:tB[h`̏W.
      * @param i tB[h`̎(oCRXgN^C\bh).
      *        <pre>
      *                  Eo ϐ    ... C_VARIABLE
      *                  ERXgN^ ... C_CONSTRUCTOR
      *                  E\bh       ... C_METHOD
      *        </pre>
      */
    void genDocumentation(PrintWriter printWriter, Vector vector, int i) {
        if (vector.size() <= 0) {
            return;
	}
	if (i == C_VARIABLE) {
	    //* oϐ̏o.
	    printWriter.println(TAB + "class_attributes " + TAB 
				+ "(list class_attribute_list");
	    for (int j = 0; j < vector.size(); j++) {
		FieldDefinition fieldDefinition = (FieldDefinition)vector.elementAt(j);
		genVariableDocumentation(printWriter, fieldDefinition);
	    }
	    printWriter.println(TAB + ")");
	} else if (i == C_CONSTRUCTOR || i == C_METHOD) {
	    //* RXgN^, \bh̏o.
	    printWriter.println(TAB + "operations" + TAB + "(list Operations");
	    for (int j = 0; j < vector.size(); j++) {
		FieldDefinition fieldDefinition = (FieldDefinition)vector.elementAt(j);
		genMethodDocumentation(printWriter, fieldDefinition);
	    }
	    printWriter.println(TAB + ")");
	}
    }

    /**
      * oϐ̏o͂.
      * @param printWriter  o͐. (*.red t@C֏o͂).
      * @param fieldDefinition oϐɊւtB[h`.
      */
    void genVariableDocumentation(PrintWriter printWriter, FieldDefinition fieldDefinition) {
	printWriter.print(TAB2 + "(object ");

        //* oϐo.
	String varName = fieldDefinition.getName().toString();
	printWriter.println("ClassAttribute \"" + varName + "\"");

	//* final 錾Ă邩ǂȂǂ attribute o.
	printWriter.print(TAB3 + "attributes " + TAB +"(list Attribute_Set");
        if (fieldDefinition.isFinal() == true) {
	    printWriter.println(NL + TAB3 +"    (object Attribute");
	    printWriter.println(TAB4 + "tool      " + TAB +"\"cg\"");
	    printWriter.println(TAB4 + "name      " + TAB +"\"Final\"");
	    printWriter.print(TAB4 + "value      " + TAB +"TRUE)");
	}
	printWriter.println(")");

	//* oϐ̃Rgo.
        String allComments = fieldDefinition.getDocumentation();
        genAllComments(printWriter, allComments, null);
	printWriter.print(NL);

	//* oϐ̌^o.
	//          (2Ԗڂ̈false  ť^ƂȂ)
	String varType = fieldDefinition.getType().typeString("", false, false);
	//varType = varType.replace('.', '/');
	printWriter.println(TAB3 + "type      " + TAB +"\"" + varType + "\"");
 
	//* oϐ̃ANZXo͂.
        if (fieldDefinition.isPublic() == true) {
	    printWriter.print(TAB3 + "exportControl" + TAB + "\"Public\"");
	} else if (fieldDefinition.isProtected() == true) {
	    printWriter.print(TAB3 + "exportControl" + TAB + "\"Protected\"");
	} else if (fieldDefinition.isPrivate() == true) {
	    //printWriter.print(TAB3 + "exportControl" + TAB + "\"Private\"");
	}

	//* static 錾Ă邩ǂo.
        if (fieldDefinition.isStatic() == true) {
	    printWriter.print(NL +TAB3 + "static     " + TAB + "TRUE");
	}
	printWriter.println(")");
    }

    /**
      * \bh̏o͂.
      * @param printWriter  o͐. (*.red t@C֏o͂).
      * @param methodDef \bhɊւtB[h`.
      */
    void genMethodDocumentation(PrintWriter printWriter, FieldDefinition methodDef) {
	printWriter.print(TAB2 + "    (object ");

	//* \bho͂.
        String referenceName = DocumentationGenerator.getReferenceName(methodDef);
	printWriter.println("Operation \"" + referenceName + "\"");

	//* \bh̃Rgo.
        String allComments = methodDef.getDocumentation();
        FieldDefinition overrides = getOverride(methodDef);
        if (overrides != null && allComments == null) {
            allComments = "";
	}
        genAllComments(printWriter, allComments, methodDef);

	//* \bh̕Ԃľ^o.
	String methodReturn = "";
        if (methodDef.isConstructor() == false) {
	    methodReturn = methodDef.getType().getReturnType().typeString("", false, false);
        } else {
	    //methodReturn = "(RXgN^Ȃ̂łȂ)";
	}
	//methodReturn = methodReturn.replace('.', '/');
	printWriter.println(TAB3 + "result      " + TAB + "\"" + methodReturn + "\"");

	//* \bh̃ANZXo.
        if (methodDef.isPublic() == true) {
	    printWriter.println(TAB3 + "opExportControl" + TAB + "\"Public\"");
	} else if (methodDef.isProtected() == true) {
	    printWriter.println(TAB3 + "opExportControl" + TAB + "\"Protected\"");
	} else if (methodDef.isPrivate() == true) {
	    //printWriter.println(TAB3 + "opExportControl" + TAB + "\"Private\"");
	}

	//* concurrency ̏o.
	printWriter.println(TAB3 + "concurrency " + TAB + "\"Sequential\"");

	//* ̖Oƌ^o͂.
	printWriter.print(TAB3 + "parameters" + TAB + "(list Parameters");
	genParametersDocumentation(printWriter, methodDef);
	printWriter.println(")");

	// abstract \bhǂȂǂ attribute o͂.
	printWriter.print(TAB3 + "attributes " + TAB +"(list Attribute_Set");
	//Abstract ǂ
	/*************
	if (methodDef.isAbstract() == true) {
	    printWriter.println("");
	    printWriter.println(TAB4 +"    (object Attribute");
	    printWriter.println(TAB4 + TAB + "tool     " + "\"cg\"");
	    printWriter.println(TAB4 + TAB + "name     " + "\"Abstract\"");
	    printWriter.print(  TAB4 + TAB + "value    " + "TRUE)");
	    printWriter.println(")");
	    //printWriter.print(TAB4 + TAB + "abstract " + "TRUE");
	}
	**************/
	printWriter.print(")");  //attributes

	//printWriter.println(TAB3 + "logical_presentatioins   (list unit_reference_list)");
	//printWriter.print(NL + TAB3 + "uid    " + TAB + "0");
	printWriter.println(")");

	// OɂĂ̏́CRoseɑΉ镔Ȃ̂ŁCo͂Ȃ.
	// Rg̏o͂ɂ܂.
        //ClassDeclaration aclassDeclaration[] = methodDef.getExceptions(env);
        //if (aclassDeclaration.length > 0) {
	//}
        printWriter.println();
    }

    /**
      * \bḧ̏o͂D
      * @param printWriter  o͐. (*.red t@C֏o͂).
      * @param methodDef \bhɊւtB[h`.
      */
    void genParametersDocumentation(PrintWriter printWriter, FieldDefinition methodDef) {
	// ̌^̗
        Type atype[] = methodDef.getType().getArgumentTypes();
	// ̖ȌW
        Enumeration enumeration = methodDef.getArguments().elements();
        if (!methodDef.isStatic()) {
            enumeration.nextElement();
	}

	String paramType = "";
	String paramName = "";
        for (int i2 = 0; i2 < atype.length; i2++)  {
	    //̖O
            LocalField localField = (LocalField)enumeration.nextElement();
            paramName = localField.getName().toString();

	    //̌^
            paramType = atype[i2].typeString("", false, false);
	    //paramType = paramType.replace('.', '/');
	    //* ̖Oƌ^o.
	    printWriter.println(NL + TAB4 + "(object Parameter \""
				+ paramName + "\"");
	    printWriter.print(TAB4 + TAB + "type " + TAB + "\"" + paramType + "\")");
	}
    }

    String classString(ClassDeclaration classDeclaration) {
        return classString(classDeclaration, classDeclaration.getName().getName());
    }

    private String classString(ClassDeclaration classDeclaration, Object className) {
        if (shouldDocument(classDeclaration))
            return className.toString();
	else
	    return "";
    }

    String authorString(String string) {
        return string;
    }

    String commentString(String string) {
        return string;
    }

    String versionString(String string) {
        return string;
    }

    String returnString(String string) {
        return string;
    }


    /**
      * Start of the red file.
      */
    private void redStart(PrintWriter printWriter) {

	// header.
	printWriter.println(
	    "(object Petal" + NL + TAB + "version 37)" + NL
	    );

	// here, opens 3 parens.
	printWriter.println(
	    "(object Design \"<Top Level>\"" + NL +
	    TAB + "root_category (object Class_Category \"<Top Level>\"" + NL +
	    TAB2 + "exportControl \"Public\"" + NL +
	    TAB2 + "global TRUE" + NL +
	    TAB2 + "subsystem \"<Top Level>\"" + NL +
	    TAB2 + "logical_models (list unit_reference_list"
	    );
    }

    /**
      * End of the red file.
      */
    private static void redEnd(PrintWriter printWriter)  {
	// here closes 3 parens.
	printWriter.println(")))");   // object, root category, logical_model... corresponds with redStart.
        printWriter.close();
    }

    /**
      * Handles multiline documentation in RED way.
      * @param trim if true, removes one beginning white space.(hack for starting comment)
      */
    private static void handleMultiLine(PrintWriter printWriter, String lines, boolean trim) {
	BufferedReader reader = new BufferedReader(new StringReader(lines));
	String line;

	try {
	    while ((line = reader.readLine()) != null) {
		if (trim && Character.isWhitespace(line.charAt(0))) {
		    line = line.substring(1);
		}
		printWriter.print("|");
		printWriter.println(removeHTMLTags(line));
	    }
	} catch (EOFException e) {
	} catch (IOException e) {
	    System.out.println("IOException occurred when reading.");
	}
    }

    /**
      * Removes <html-tags>
      */
    private static String removeHTMLTags(String string) {
	int start = 0;
	int end = 0;
	int next_start = 0;
	int i = 0;
	StringBuffer out = new StringBuffer();

	for (i = 0; ; i++) {
	    start = string.indexOf('<', next_start);
	    if (start < 0)
		break;
	    end = string.indexOf('>', start);
	    if (end < 0)
		break;
	    // start end exist.
	    out.append(string.substring(next_start,  start));
	    next_start = end + 1;
	}
	out.append(string.substring(next_start));

	return out.toString();
    }

    /**
      * Generates all comment for Class, Method, or Variable
      */
    private void genAllComments(PrintWriter printWriter, String allComments, FieldDefinition fieldDefinition) {
        if (allComments != null) {
            Vector eachComment = DocumentationGenerator.mergeDoc(allComments);

            String comment = getComment(eachComment);
	    // The firt white spaces are seems to be omitted.
	    // System.out.println("raw comment = " + comment);
            String author = getAuthors(eachComment);
            String version = getVersion(eachComment);
	    // I don't know why by jdk 1.1.4 version of javadoc doesn't make author and version tag.
	    // System.out.println("author = " + author);
	    // System.out.println("version = " + version);
            Vector params = getParameters(eachComment);
            String ret = getReturn(eachComment);
	    Vector exceptions = null;
	    if (fieldDefinition != null)
		exceptions = getThrows(eachComment, fieldDefinition); 
            Vector seeAlso = getSees(eachComment, currentClass);
            String depre = getDeprecated(eachComment);


            if (comment != null	||
		author != null ||
		version != null ||
		params != null && params.size() > 0 ||
		ret != null ||
		exceptions != null && exceptions.size() > 0 ||
		seeAlso != null && seeAlso.size() > 0 ||
		depre != null) {

		// print class Documentation
		printWriter.println(
		    TAB + "documentation"
		    );
	    }

            if (comment != null)
		handleCommentDoc(printWriter, comment);
            if (author != null)
		handleAuthorDoc(printWriter, author);
	    if (version != null)
		handleVersionDoc(printWriter, version);
	    if (params != null && params.size() > 0)
		handleParamsDoc(printWriter, params);
	    if (ret != null)
		handleReturnDoc(printWriter, ret);
	    if (exceptions != null && exceptions.size() > 0)
		handleExceptionsDoc(printWriter, exceptions);
	    if (seeAlso != null && seeAlso.size() > 0)
		handleSeeAlsoDoc(printWriter, seeAlso);
	    if (depre != null)
		handleDeprecationDoc(printWriter, depre);
	}
    }

    /**
      * Rg̏
      */
    private void handleCommentDoc(PrintWriter printWriter, String comment) {
	// System.out.println("handleComment: " + comment);
	// javadoc removes all white spaces upto the beginning of the comment.
	// so added one " " to the beginning of the comment.
	handleMultiLine(printWriter, comment, true);
    }
    /**
      * Authoȑ
      */
    private void handleAuthorDoc(PrintWriter printWriter, String  author) {
	// System.out.println("handleAuthor: " + author);
	//handleMultiLine(printWriter, NL + ": " + author, false);
	handleMultiLine(printWriter, NL + "Author: " + author, false);
    }
    /**
      * version ̏
      */
    private void handleVersionDoc(PrintWriter printWriter, String version) {
	// System.out.println("handleVersion: " + version);
	//handleMultiLine(printWriter, NL + "o[W: " + version, false);
	handleMultiLine(printWriter, NL + "Version: " + version, false);
    }

    /**
      * deprecation ̏
      */
    private void handleDeprecationDoc(PrintWriter printWriter, String depre) {
	//handleMultiLine(printWriter, NL + "()dl̂ߎgpȂƂ𐄏: " + depre, false);
	handleMultiLine(printWriter, NL + "- Deprecated -" + depre, false);
    }

    /**
      * return ̏
      */
    private void handleReturnDoc(PrintWriter printWriter, String ret) {
	//handleMultiLine(printWriter, NL + "Ԃl: " + ret, false);
	handleMultiLine(printWriter, NL + "Return value: " + ret, false);
    }

    /**
      * See also ̏
      */
    private void handleSeeAlsoDoc(PrintWriter printWriter, Vector seeAlso) {
	handleMultiLine(printWriter, NL, false);
        for (Enumeration e = seeAlso.elements(); e.hasMoreElements(); ) {
            ClassDeclaration classDeclaration = (ClassDeclaration)e.nextElement();
            String tag = (String)e.nextElement();
            String comment = (String)e.nextElement();

	    handleMultiLine(printWriter, "See Also: " + classDeclaration.getName().getName().toString() + "#" + tag, false);
        }
    }

    /**
      * param ̏
      */
    private void handleParamsDoc(PrintWriter printWriter, Vector params) {
	//handleMultiLine(printWriter, NL + ":", false);
	handleMultiLine(printWriter, NL + "Arguments:", false);
        for (Enumeration e = params.elements(); e.hasMoreElements(); ) {
            String name = (String)e.nextElement();
            String comment = (String)e.nextElement();
	    handleMultiLine(printWriter, "       " + name + " - " + comment, false);
        }
    }

    /**
      * exception ̏
      */
    private void handleExceptionsDoc(PrintWriter printWriter, Vector exceptions) {
	//handleMultiLine(printWriter, NL + "O:", false);
	handleMultiLine(printWriter, NL + "Exceptions:", false);
        for (Enumeration e = exceptions.elements(); e.hasMoreElements(); ) {
            ClassDeclaration clazz = (ClassDeclaration)e.nextElement();
	    String name = clazz.getName().getName().toString();
            String comment = (String)e.nextElement();
	    handleMultiLine(printWriter, "      " + name + " - " + comment, false);
        }
    }
}


/*

R[fBȌڍ׃

 ClassDefinition ̎dl

1. classDefinition -> NX(Color)

 String className = classDefinition.getName().getName().toString();

2. classDefinition -> SNX(java.awt.Color)

 String fullClassName = getReferenceName(classDefinition);

3. classDefinition -> pbP[W

 String packageName = classDefinition.getName().getQualifier().toString();

4. pbP[W -> JeS

 String categoryName = packageName.replace('.','/');

 DocumentationGenerator ̎dl

javadoc Őt@ĆCȉ̒ʂD

1. Packages.html

\
--------------
pbP[W̗
--------------

Ή\bh

void genPackagesDocumentation(String[] s, String[] t)

2. <package.name>.html

NX̗

\
---------
pbP[W

interface ̗
class ̗
exception ̗
error ̗
---------

Ή\bh

void genPackageDocumentation(Identifier packageIdentifier,
			 ClassDeclaration[] interfaceDeclaration,
			 ClassDeclaration[] classDeclaration,
			 ClassDeclaration[] exceptionDeclaration,
			 ClassDeclaration[] ErrorDeclaration)

3. <package.name.ClassName>.html

\
--------------
NX

p֌W

NX̃hLg

ϐ Index
RXgN^ Index
\bh Index

ϐڍ
RXgN^ڍ
\bhڍ
--------------

Ή\bh

void genClassDocumentation(ClassDeclaration classDeclaration,
       ClassDeclaration prevClass, ClassDeclaration nextClass) {


Rose file ̎dl



(object Petal version@37)                        ... version 



(object Design ....(...(list ...                  ... fUC

(object Class_Category "java.awt" ...(list ..... JeS

(object Class "Button"....                    ... NX

class_attributes (list ...                
                                          
(object ClassAttribute "label")           ... 
....                                      
)                                         


class_operations (list ...                
                                          
(object ClassOperation "getLabel")        ... 
....                                      
)                                         





(object Class_Category "java.awt" ...        ... NXɌJԂ

(object Class "Frame" ....


  

 ......



*/
